; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_TEMP1_BIS_TEMP4_PLUS_EINS:
	; ADDIEREN						
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_TEMP1_BIS_TEMP4_MINUS_EINS:
	; SUBTRAHIEREN						
	sub temp1,EINS
	sbc temp2,NULL
	sbc temp3,NULL
	sbc temp4,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	mul	temp4,temp2		; ah * bh
	mov	temp7,r0
	mov	temp8,r1
	mul	temp3,temp1		; al * bl
	mov	temp5,r0
	mov	temp6,r1
	mul	temp4,temp1		; ah * bl
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2
	mul	temp2,temp3		; bh * al
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2


	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5

ret


; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_DIVISION_32_1000:
	ldi temp5,LOW (1000)
	ldi temp6,HIGH(1000)
	rcall FUNCTION_DIVISION_32_16
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
FUNCTION_DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	push R0
	push R1
	push temp
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
	pop temp
	pop R1
	pop R0	
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: 		temp8 		(BIT-START)	
; inp; 		temp9		(BIT_ENDE)	
; ZL/ZH:	SRAM					
; OUT: 		temp1..5				
; Hilfsregister: R0, R1				
FUNKTION_SRAM_SELECT_Z_8_9:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	clr temp5
	ldi temp,0b10000000
	mov R1,temp			; Hilfsregister	
	inc temp9
	sub temp9,temp8		; Schleife		
FUNK_SRAM_s:
	mov temp,temp8		; (BIT-NR)		
	andi temp,0b11111000
	LSR temp			; rechts ohne C	
	LSR temp
	LSR temp
	push ZL				; Z sichern		
	push ZH
	sub ZL,temp			; subtrahieren	
	sbc ZH,NULL
	LD R0,Z				; load			
	pop ZH				; Z wiederherstellen
	pop ZL
; ------------------------------------------------------------------------------
	mov temp,temp8		; (BIT-NR)			
	andi temp,0b00000111
	cpi temp,0
	breq FUNK_SRAM0
	cpi temp,1
	breq FUNK_SRAM1
	cpi temp,2
	breq FUNK_SRAM2
	cpi temp,3
	breq FUNK_SRAM3
	cpi temp,4
	breq FUNK_SRAM4
	cpi temp,5
	breq FUNK_SRAM5
	cpi temp,6
	breq FUNK_SRAM6
	rjmp FUNK_SRAM7
; ------------------------------------------------------------------------------
FUNK_SRAM0:
	CLC				; Clear C	
	SBRC R0,0
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM1:
	CLC				; Clear C	
	SBRC R0,1
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM2:
	CLC				; Clear C	
	SBRC R0,2
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM3:
	CLC				; Clear C	
	SBRC R0,3
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM4:
	CLC				; Clear C	
	SBRC R0,4
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM5:
	CLC				; Clear C	
	SBRC R0,5
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM6:
	CLC				; Clear C	
	SBRC R0,6
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM7:
	CLC				; Clear C	
	SBRC R0,7
	SEC 			; Set C		
	rjmp FUNK_SRAM_w
FUNK_SRAM_w:
	rcall FUNK_SRAM_RECHTS_C	; rechts ber C
	inc temp8		; (BIT-NR)	
	dec temp9		; Schleife	
	breq FUNK_SRAM_w2
	rjmp FUNK_SRAM_s
; ------------------------------------------------------------------------------
FUNK_SRAM_w2:
	SBRC temp1,0	
	rjmp FUNK_SRAM_w3
	CLC				; Clear C	
	rcall FUNK_SRAM_RECHTS_C	; rechts ber C
	rjmp FUNK_SRAM_w2
; ------------------------------------------------------------------------------
FUNK_SRAM_w3:
	CLC				; Clear C	
	rcall FUNK_SRAM_RECHTS_C	; rechts ber C
	ret
; ------------------------------------------------------------------------------
FUNK_SRAM_RECHTS_C:
	ROR R1			; rechts ber C
	ROR temp5
	ROR temp4
	ROR temp3
	ROR temp2
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


