; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; LCD 2x16 4x16 4x20 ZEICHEN													
;																				
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_EN_PORT),(LCD_EN)
	cbi (LCD_RS_PORT),(LCD_RS)
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_EN_DDR),(LCD_EN)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS)	; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	rcall LCD_ENABLE					; 1	
	rcall LCD_ENABLE					; 2	
	rcall LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen		
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND_TEMP
;    ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken	
    ldi temp, 0b00001100         ; DISPLAY ein / CURSOR off		
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000110        ; Cursor Auto-Increment		
 	rcall LCD_COMMAND_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
	sbi (LCD_EN_PORT),(LCD_EN) 					; Enable high		
   	rcall wait_50us                   			; kurze PAUSE		
	cbi (LCD_EN_PORT),(LCD_EN)  				; Enable low		
	rjmp  wait_50us                   			; kurze PAUSE		
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA_TEMP:
	sbi (LCD_RS_PORT),(LCD_RS) 				; RS ein/auf DATA (high)				
LCD_DATA_TEMP_RS:
	cbi (LCD_DATA0_PORT),(LCD_DATA0)		; alle auf LOW							
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
;-------------------------------------------------------------------------------
	cbi (LCD_DATA0_PORT),(LCD_DATA0)	; auf LOW								
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
	rcall wait_5us						; Pause 								
	sbi (LCD_RS_PORT),(LCD_RS)			; vorsichtshalber RS ein/auf DATA (high)
ret				                       
; ##############################################################################
; ##############################################################################
; ##############################################################################
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  		
; INP: temp															  			
LCD_COMMAND_TEMP:                            
    cbi (LCD_RS_PORT),(LCD_RS)			;	 RS aus (low)				
	rcall LCD_DATA_TEMP_RS
	rjmp wait_5ms						; Pause (wichtig)				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; eine Text anzeigen INP: Z														
LCD_ANZEIGE_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq LCD_ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA_TEMP		; Anzeige
	rjmp LCD_ANZEIGE_TEXT_Z
LCD_ANZEIGE_TEXT_e:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display lschen														  		
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall LCD_COMMAND_TEMP
	rcall wait_5ms						; Pause (wichtig)				
	rjmp LCD_ZEILE1
; ##############################################################################
; KURSOR Sprung in ZEILE!												  		
LCD_ZEILE1:
 	ldi temp, 0b00000010
	rjmp LCD_COMMAND_TEMP
; ##############################################################################
; KURSOR Sprung in ZEILE2												  		
LCD_ZEILE2:
 	ldi temp, 0b11000000 
	rjmp LCD_COMMAND_TEMP
; ##############################################################################
; KURSOR Sprung in ZEILE3												  		
LCD_ZEILE3:
; 	ldi temp, 0b10010100  	; LCD 4x20	
	ldi temp, 0b10010000 	; 4x16		
	rjmp LCD_COMMAND_TEMP
; ##############################################################################
; KURSOR Sprung in ZEILE4												  		
LCD_ZEILE4:
;	ldi temp, 0b11010100	; LCD 4x20	
	ldi temp, 0b11010000 	; 4x16		
	rjmp LCD_COMMAND_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ohne SPACE !																	
; z.B: "06"																		
LCD_ZAHL_2STELLEN_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	rjmp LCD_STELLE_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Value: 0...99.999.999															
LCD_ZAHL_TEMP1:
	clr temp2
	clr temp3
	clr temp4
LCD_ZAHL_TEMP1_2:
	clr temp3
	clr temp4
LCD_ZAHL_TEMP1_2_3:
	clr temp4
LCD_ZAHL_TEMP1_2_3_4:
	rcall FUNKTION_HEX_ASCII_TEMP1_4
; ------------------------------------------------------------------------------
LCD_ZAHL_FORMAT_10:
	mov temp,R0
	cpi temp,'0'
	breq LCD_ZAHL_FORMAT_9
	rcall LCD_STELLE_10
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_9:
	cpi temp9,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_8
	rcall LCD_STELLE_9
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_8:
	cpi temp8,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_7
	rcall LCD_STELLE_8
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_7:
	cpi temp7,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_6
	rcall LCD_STELLE_7
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_6:
	cpi temp6,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_5
	rcall LCD_STELLE_6
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_5:
	cpi temp5,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_4
	rcall LCD_STELLE_5
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_4:
	cpi temp4,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_3
	rcall LCD_STELLE_4
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_3:
	cpi temp3,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_2
	rcall LCD_STELLE_3
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_2:
	cpi temp2,'0'	; 0 ?	
	breq LCD_ZAHL_FORMAT_1
	rcall LCD_STELLE_2
	rjmp LCD_SPACE
LCD_ZAHL_FORMAT_1:
	rcall LCD_STELLE_1
	rjmp LCD_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...TEMP9...R0												  		
LCD_STELLE_10:
	mov temp, R0			; 10.ZEICHEN 
	rcall LCD_DATA_TEMP
	rcall LCD_PUNKT			; '.'
LCD_STELLE_9:
	mov temp, temp9			; 9.ZEICHEN 
	rcall LCD_DATA_TEMP
LCD_STELLE_8:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_STELLE_7:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA_TEMP	
	rcall LCD_PUNKT			; '.'
LCD_STELLE_6:
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_STELLE_5:
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_STELLE_4:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA_TEMP	
	rcall LCD_PUNKT			; '.'
LCD_STELLE_3:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_STELLE_2:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_STELLE_1:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rjmp  LCD_DATA_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 04/2017																
;																				
;	Value: 0...	4.294.967.295													
;																				
;	INPUT: 	temp1	(BYTE1)														
;	 		temp2	(BYTE2)														
;			temp3	(BYTE3)														
;			temp4	(BYTE4)														
;																				
;	OUTPUT:	temp1	(		    1-er Stelle)									
;			temp2	(		   10-er Stelle)									
;			temp3	(         100-er Stelle)									
;			temp4	(       1.000-er Stelle)									
;			temp5	(      10.000-er Stelle)									
;			temp6	(     100.000-er Stelle)									
;			temp7	(   1.000.000-er Stelle)									
;			temp8	(  10.000.000-er Stelle)									
;			temp9	( 100.000.000-er Stelle)									
; 			R0		(1.000.000.000-er Stelle)									
FUNKTION_HEX_ASCII_TEMP1_4:
	clr temp
FUNKTION_HEX_ASC_1000000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_1000000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird R0) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)

	clr temp
FUNKTION_HEX_ASC_100000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_100000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp9) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:; 1.000.000
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
	pop	TEMP9			; LESEN vom STACK (KOPIE)
	pop R0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
LCD_ANZEIGE_HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	rcall LCD_ANZEIGE_HEX_UMWANDLUNG; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	rcall LCD_ANZEIGE_HEX_UMWANDLUNG; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
LCD_ANZEIGE_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh LCD_ANZEIGE_HEX_UMWANDLUNG_A_F
LCD_ANZEIGE_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
LCD_ANZEIGE_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;-------------------------------------------------------------------------------
LCD_SPACE8:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE7:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE6:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE5:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE4:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE3:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE2:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE:
	ldi temp, ' '			; SPACE
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_PUNKT:
	ldi temp, '.'			; PUNKT
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_PUNKT3:
	ldi temp, '.'			;3 PUNKT
	call LCD_DATA_TEMP	
	call LCD_DATA_TEMP	
	jmp  LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_DOPPEL_PUNKT:
	ldi temp, ':'			; DOPPELPUNKT
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_DOPPEL_PUNKT_SPACE:
	ldi temp, ':'			; ': '	
	call LCD_DATA_TEMP
	jmp LCD_SPACE
;-------------------------------------------------------------------------------
LCD_MINUS4:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS3:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS2:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS:
	ldi temp, '-'			; '-'	
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_GRD:
	ldi temp,223
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_STERN:
	ldi temp,'*'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_FRAGEZEICHEN:
	ldi temp,'?'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_SCHRAEGSTRICH:
	ldi temp,'/'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_KLAMMER_AUF:
	ldi temp,'('
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_KLAMMER_ZU:
	ldi temp,')'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_0:
	ldi temp, '0'
	jmp LCD_DATA_TEMP	
LCD_1:
	ldi temp, '1'
	jmp LCD_DATA_TEMP	
LCD_2:
	ldi temp, '2'
	jmp LCD_DATA_TEMP	
LCD_3:
	ldi temp, '3'
	jmp LCD_DATA_TEMP	
LCD_4:
	ldi temp, '4'
	jmp LCD_DATA_TEMP	
LCD_5:
	ldi temp, '5'
	jmp LCD_DATA_TEMP	
LCD_6:
	ldi temp, '6'
	jmp LCD_DATA_TEMP	
LCD_7:
	ldi temp, '7'
	jmp LCD_DATA_TEMP	
LCD_8:
	ldi temp, '8'
	jmp LCD_DATA_TEMP	
LCD_9:
	ldi temp, '9'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_A:
	ldi temp, 'A'
	jmp LCD_DATA_TEMP	
LCD_B:
	ldi temp, 'B'
	jmp LCD_DATA_TEMP	
LCD_C:
	ldi temp, 'C'
	jmp LCD_DATA_TEMP	
LCD_D:
	ldi temp, 'D'
	jmp LCD_DATA_TEMP	
LCD_E:
	ldi temp, 'E'
	jmp LCD_DATA_TEMP	
LCD_F:
	ldi temp, 'F'
	jmp LCD_DATA_TEMP	
LCD_G:
	ldi temp, 'G'
	jmp LCD_DATA_TEMP	
LCD_H:
	ldi temp, 'H'
	jmp LCD_DATA_TEMP	
LCD_I:
	ldi temp, 'I'
	jmp LCD_DATA_TEMP	
LCD_J:
	ldi temp, 'J'
	jmp LCD_DATA_TEMP	
LCD_K:
	ldi temp, 'K'
	jmp LCD_DATA_TEMP	
LCD_L:
	ldi temp, 'L'
	jmp LCD_DATA_TEMP	
LCD_M:
	ldi temp, 'M'
	jmp LCD_DATA_TEMP	
LCD_N:
	ldi temp, 'N'
	jmp LCD_DATA_TEMP	
LCD_O:
	ldi temp, 'O'
	jmp LCD_DATA_TEMP	
LCD_P:
	ldi temp, 'P'
	jmp LCD_DATA_TEMP	
LCD_Q:
	ldi temp, 'Q'
	jmp LCD_DATA_TEMP	
LCD_R:
	ldi temp, 'R'
	jmp LCD_DATA_TEMP	
LCD_S:
	ldi temp, 'S'
	jmp LCD_DATA_TEMP	
LCD_T:
	ldi temp, 'T'
	jmp LCD_DATA_TEMP	
LCD_U:
	ldi temp, 'U'
	jmp LCD_DATA_TEMP	
LCD_V:
	ldi temp, 'V'
	jmp LCD_DATA_TEMP	
LCD_W:
	ldi temp, 'W'
	jmp LCD_DATA_TEMP	
LCD_X:
	ldi temp, 'X'
	jmp LCD_DATA_TEMP	
LCD_Y:
	ldi temp, 'Y'
	jmp LCD_DATA_TEMP	
LCD_Z:
	ldi temp, 'Z'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_A_:
	ldi temp, 'a'
	jmp LCD_DATA_TEMP	
LCD_B_:
	ldi temp, 'b'
	jmp LCD_DATA_TEMP	
LCD_C_:
	ldi temp, 'c'
	jmp LCD_DATA_TEMP	
LCD_D_:
	ldi temp, 'd'
	jmp LCD_DATA_TEMP	
LCD_E_:
	ldi temp, 'e'
	jmp LCD_DATA_TEMP	
LCD_F_:
	ldi temp, 'f'
	jmp LCD_DATA_TEMP	
LCD_G_:
	ldi temp, 'g'
	jmp LCD_DATA_TEMP	
LCD_H_:
	ldi temp, 'h'
	jmp LCD_DATA_TEMP	
LCD_I_:
	ldi temp, 'i'
	jmp LCD_DATA_TEMP	
LCD_J_:
	ldi temp, 'j'
	jmp LCD_DATA_TEMP	
LCD_K_:
	ldi temp, 'k'
	jmp LCD_DATA_TEMP	
LCD_L_:
	ldi temp, 'l'
	jmp LCD_DATA_TEMP	
LCD_M_:
	ldi temp, 'm'
	jmp LCD_DATA_TEMP	
LCD_N_:
	ldi temp, 'n'
	jmp LCD_DATA_TEMP	
LCD_O_:
	ldi temp, 'o'
	jmp LCD_DATA_TEMP	
LCD_P_:
	ldi temp, 'p'
	jmp LCD_DATA_TEMP	
LCD_Q_:
	ldi temp, 'q'
	jmp LCD_DATA_TEMP	
LCD_R_:
	ldi temp, 'r'
	jmp LCD_DATA_TEMP	
LCD_S_:
	ldi temp, 's'
	jmp LCD_DATA_TEMP	
LCD_T_:
	ldi temp, 't'
	jmp LCD_DATA_TEMP	
LCD_U_:
	ldi temp, 'u'
	jmp LCD_DATA_TEMP	
LCD_V_:
	ldi temp, 'v'
	jmp LCD_DATA_TEMP	
LCD_W_:
	ldi temp, 'w'
	jmp LCD_DATA_TEMP	
LCD_X_:
	ldi temp, 'x'
	jmp LCD_DATA_TEMP	
LCD_Y_:
	ldi temp, 'y'
	jmp LCD_DATA_TEMP	
LCD_Z_:
	ldi temp, 'z'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------































