; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CHECK:
	rcall SD_CMD10_CID
	tst FEHLER_CODE
	brne SD_INITIALISIERUNG
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
ret
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_0
	call LCD_SPACE
	call LCD_n_
	call LCD_o_
	call LCD_SPACE
	call LCD_C
	call LCD_a_
	call LCD_r_
	call LCD_d_
	call SD_CMD0_IDLE	; RESET				
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_8
	call SD_CMD8_SDHC_Karten
	tst FEHLER_CODE
	breq SD_INITIALISIERUNG_OK
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_ACMD
	call LCD_4
	call LCD_1
	call SD_ACMD41_BETRIEBSMODUS	; Initialisierung	
	tst FEHLER_CODE
	breq SD_INITIALISIERUNG_OK
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_1
	call SD_CMD1_BETRIEBSMODUS	; Initialisierung	
	tst FEHLER_CODE
	breq SD_INITIALISIERUNG_OK
	rjmp SD_INITIALISIERUNG		; nochmal !!!		
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_OK:
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_1
	call LCD_6
	call SD_CMD16	; Blocklnge setzen (512Byte)
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_9
	call SD_CMD9_CSD; CSD - Register auslesen (Card Specific Data)	
;-------------------------------------------------------------------------------
	call LCD_CLEAR	; CLEAR		
	call LCD_TEXT_CMD
	call LCD_1
	call LCD_0
	call SD_CMD10_CID; CID - Register auslesen (card identification)
;-------------------------------------------------------------------------------
	;call SD_CMD_13
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Karte in den IDLE MODUS versetzen												
; Send: 0x40 0x00 0x00 0x00 0x00 0x95 (CMD0)									
; Recv: 0x01 (R1-Antwort mit dem "In Idle State"-Bit gesetzt.)					
SD_CMD0_IDLE:
	call WAIT_100ms
	sbi (SPI_PORT_CS),(SPI_CS)	; CS auf HIGH	
	ldi temp9,4
SD_CMD0_s:
	WDR
	call SPI_DUMMY_255			; mindestens 74 CLOCKS senden, CS und MOSI auf HIGH		
	dec temp9
	brne SD_CMD0_s
; ------------------------------------------------------------------------------
	ldi temp1, 0x40
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x95
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp,0x01				; vergleich		
	breq SD_CMD0_OK
	call SPI_CLEAR
	rjmp SD_CMD0_IDLE
; ------------------------------------------------------------------------------
SD_CMD0_OK:
	call SPI_CLEAR
	mov FEHLER_CODE,NULL		; FEHLER CODE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; Send: 0x41 0x00 0x00 0x00 0x00 0x01 (CMD1)									
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
SD_CMD1_BETRIEBSMODUS:
	ldi temp9, 10
SD_CMD1_s:
	ldi temp1, 0x41
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
	call SPI_TX_xFF_RX_TEMP		; OUT:temp	
	cpi temp,0x00				; vergleich		
	breq SD_CMD1_OK
	call SPI_CLEAR
	dec temp9
	brne SD_CMD1_s
; ------------------------------------------------------------------------------
SD_CMD1_ERROR:
	mov FEHLER_CODE,VOLL		; FEHLER CODE	
	call SPI_CLEAR
	ret
; ------------------------------------------------------------------------------
SD_CMD1_OK:
	call LCD_TEXT_OK
	call WAIT_1s
	mov FEHLER_CODE,NULL		; FEHLER CODE	
	call SPI_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; Send: 0x77 0x00 0x00 0x00 0x00 0x01 (CMD55, das "Prefix" fr ein ACMD)		
; Recv: 0x01 (R1-noch "In Idle State")											
; Send: 0x69 0x00 0x00 0x00 0x00 0x01 (ACMD41)									
; Recv: 0x01 (R1-noch "In Idle State")											
; ....																			
; Send: 0x77 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x01 oder 0x00															
; Send: 0x69 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
SD_ACMD41_BETRIEBSMODUS:
	ldi temp9,10
SD_ACMD41_s:
	rcall CMD55_PREFIX_ACMD
	ldi temp1, 0x69
	ldi temp2, 0x00 ;0x40
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY						
; ------------------------------------------------------------------------------
;	call SPI_DEBUG_ANZEIGE
;	call TEST_ZAEHLER_PLUS
;	rjmp SD_ACMD41_BETRIEBSMODUS	
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp, 0x00
	breq SD_ACMD41_OK
	call SPI_CLEAR
	call WAIT_100ms
	dec temp9
	brne SD_ACMD41_s
	rjmp SD_ACMD41_ERROR
; ------------------------------------------------------------------------------
SD_ACMD41_ERROR:
	mov FEHLER_CODE,VOLL		; FEHLER CODE	
	call SPI_CLEAR
	ret
; ------------------------------------------------------------------------------
SD_ACMD41_OK:
	call LCD_TEXT_OK
	call WAIT_1s
	mov FEHLER_CODE,NULL		; FEHLER CODE	
	call SPI_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD8 wird nur zum Initialisieren von SDHC-Karten mit							
; einer Kapazitt von 4GB und mehr gebraucht									
; Send: 0x48 0x00 0x00 0x01 0xAA 0x87 											
; Recv: 0x01 0x00 0x00 0x01 0xAA												
SD_CMD8_SDHC_Karten:	
	ldi temp9,100
SD_CMD8_s:
	WDR
	ldi temp1, 0x48				; CMD8					
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x01
	ldi temp5, 0xAA
	ldi temp6, 0x87
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
	call SPI_CLEAR
; ------------------------------------------------------------------------------
	ldi temp1, 0x77				; CMD55 (Prefix fr ACMD)
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
	call SPI_CLEAR
; ------------------------------------------------------------------------------
	ldi temp1, 0x69
	ldi temp2, 0x40 			;0x40
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
;	call SPI_DEBUG_ANZEIGE
;	call TEST_ZAEHLER_PLUS
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp,0x00				; auf 0x00 warten
	breq SD_CMD8_OK
	dec temp9
	breq SD_CMD8_ERROR
	call SPI_CLEAR
	rjmp SD_CMD8_s
; ------------------------------------------------------------------------------
SD_CMD8_ERROR:
	mov FEHLER_CODE,VOLL		; FEHLER CODE	
	call SPI_CLEAR
ret
; ------------------------------------------------------------------------------
SD_CMD8_OK:
	call LCD_TEXT_OK
	call WAIT_1s
	mov FEHLER_CODE,NULL		; FEHLER CODE	
	call SPI_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CSD - Register auslesen (Card Specific Data)									
SD_CMD9_CSD:
	ldi temp1, 0x49				;  0x49, 0x00, 0x00, 0x00, 0x00, 0x00
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
	ldi temp8,10
SD_CMD9_s1:
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp,0xFE				; auf  0xFE warten			
	breq SD_CMD9_OK
	dec temp8
	brne SD_CMD9_s1
	rjmp SD_CMD9_ERROR
; ------------------------------------------------------------------------------
SD_CMD9_ERROR:
	call SPI_CLEAR
	mov FEHLER_CODE,VOLL		; FEHLER CODE	
	ret
; ------------------------------------------------------------------------------
SD_CMD9_OK:
	ldi ZL,LOW (adr_SD_CSD_REGISTER_BEREICH)
	ldi ZH,HIGH(adr_SD_CSD_REGISTER_BEREICH)
	ldi temp9,20
SD_CMD9_s2:
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	ST Z+,temp
	dec temp9
	brne SD_CMD9_s2
	call SPI_CLEAR
	call SD_CALC_CSD
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CID - Register auslesen (card identification)									
SD_CMD10_CID:
	ldi temp9,3					; SCHLEIFE	
SD_CMD10_CID_s:
	ldi temp1, 0x4A
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
;	call SPI_DEBUG_ANZEIGE
;	call TEST_ZAEHLER_PLUS
	ldi temp8,10				; SCHLEIFE	
SD_CMD10_CID_1:
	call SPI_TX_xFF_RX_TEMP		; OUT:temp			
	cpi temp,0xFE				; auf  0xFE warten	
	breq SD_CMD10_OK
	dec temp8
	brne SD_CMD10_CID_1
	call SPI_CLEAR
	dec temp9
	brne SD_CMD10_CID_s
	rjmp SD_CMD10_ERROR
; ------------------------------------------------------------------------------
SD_CMD10_ERROR:
	call SPI_CLEAR
	mov FEHLER_CODE,VOLL		; FEHLER CODE	
	ret
; ------------------------------------------------------------------------------
SD_CMD10_OK:
	ldi ZL,LOW (adr_SD_CID_REGISTER_BEREICH)
	ldi ZH,HIGH(adr_SD_CID_REGISTER_BEREICH)
	ldi temp9,24
SD_CMD10_s2:
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	ST Z+,temp
	dec temp9
	brne SD_CMD10_s2
	call SPI_CLEAR
	mov FEHLER_CODE,NULL		; FEHLER CODE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CMD13:
	ldi temp1, 0x40+13
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
	call SPI_DEBUG_ANZEIGE
	rjmp SD_CMD13
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Blocklnge setzen (512Byte)													
SD_CMD16:
	; CD auf HIGH	
	sbi  (SPI_PORT_CS),(SPI_CS)			
	; DUMMY			
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	; (CMD16) 0x50 0x00 0x00 0x00 0x00 0x00	; auf 512Bytes
	ldi temp1, 0x50
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x02
	ldi temp5, 0x00
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	cpi temp, 0x00
	breq SD_CMD16_OK
SD_CMD16_SCHLEIFE:
	; DUMMY senden	
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	; vergleich	
	cpi temp, 0xFF	
	breq SD_CMD16_SCHLEIFE
	; vergleich	
	cpi temp,0x00
	breq SD_CMD16_OK
	; CD auf HIGH
	sbi  (SPI_PORT_CS),(SPI_CS)		
	rjmp SD_CMD16

SD_CMD16_OK:
	sbi  (SPI_PORT_CS),(SPI_CS)		; CD auf HIGH
	; DUMMY			
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (CMD17) 0x51 0x00 0x.. 0x.. 0x.. 0x00	; auf 512Bytes							
; 512 BYTES einlesen															
SD_CMD17_RX512:
	LDS temp2,(adr_SD_PHYS_SEKTOR_BYTE3)
	LDS temp3,(adr_SD_PHYS_SEKTOR_BYTE2)
	LDS temp4,(adr_SD_PHYS_SEKTOR_BYTE1)
	LDS temp5,(adr_SD_PHYS_SEKTOR_BYTE0)
	; Umrechnen von SEKTOR in physikalische ADRESSE	 (mal 512 (9xlinks))	
	ldi temp,9
SD_CMD17_SCHLEIFE_w:
	LSL temp5
	ROL temp4
	ROL temp3
	ROL temp2
	dec temp
	brne SD_CMD17_SCHLEIFE_w 	

	ldi temp1, 0x51
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY
; ------------------------------------------------------------------------------
;	call SPI_DEBUG_ANZEIGE
SD_CMD17_s:
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp, 0xFE				; auf 0xFE warten			
	breq SD_CMD17_SCHLEIFE_RUN
	rjmp SD_CMD17_s
; ------------------------------------------------------------------------------
SD_CMD17_SCHLEIFE_RUN:
	push YL						; sichern					
	push YH
	push ZL
	push ZH
	ldi ZL, LOW(adr_SD_DATEN)	; Z-ZEIGER initialisieren	
	ldi ZH,HIGH(adr_SD_DATEN)
	ldi YL,  LOW(512)			; Y-Schleife initialisieren	
	ldi YH, HIGH(512)
SD_CMD17_SCHLEIFE_Cw:
	call SPI_TX_xFF_RX_TEMP		; DATENBYTES einlesen
	ST Z+,temp					; speichern in Z+1	
	sbiw YL,1 					; Y-1				
	tst YH
	brne SD_CMD17_SCHLEIFE_Cw
	tst YL
	brne SD_CMD17_SCHLEIFE_Cw

	pop ZH						; wiederherstellen 
	pop ZL
	pop YH
	pop YL
; ------------------------------------------------------------------------------
	;call SPI_DEBUG_ANZEIGE
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	sbi  (SPI_PORT_CS),(SPI_CS)	; CD auf HIGH
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (CMD24) 0x58 0x00 0x.. 0x.. 0x.. 0x00											
; 512 BYTES SCHREIBEN															
SD_CMD24_TX512:
	LDS temp2,(adr_SD_PHYS_SEKTOR_BYTE3)
	LDS temp3,(adr_SD_PHYS_SEKTOR_BYTE2)
	LDS temp4,(adr_SD_PHYS_SEKTOR_BYTE1)
	LDS temp5,(adr_SD_PHYS_SEKTOR_BYTE0)
	; Umrechnen von SEKTOR in physikalische ADRESSE	 (mal 512 (9xlinks))	
	ldi temp,9
SD_CMD24_SCHLEIFE_s:
	LSL temp5
	ROL temp4
	ROL temp3
	ROL temp2
	dec temp
	brne SD_CMD24_SCHLEIFE_s
	ldi temp1, 0x58
	ldi temp6, 0x00
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
; ------------------------------------------------------------------------------
	;call SPI_DEBUG_ANZEIGE
SD_CMD24_s1:
	; vergleich	
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	cpi temp, 0x00	
	brne SD_CMD24_s1
	ldi temp,0xFE				; xFE senden	
	call SPI_TX_RX_TEMP			; INP/OUT: TEMP
	; sichern					
	push YL
	push YH
	push ZL
	push ZH
	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_SD_DATEN)
	ldi ZH,HIGH(adr_SD_DATEN)
	; Y-Schleife initialisieren	
	ldi YL,  LOW(512)
	ldi YH, HIGH(512)
SD_CMD24_SCHLEIFE_C:
	; BYTES senden Z+1			
	LD temp,Z+
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	; Y-1				
	sbiw YL,1 
	tst YH
	brne SD_CMD24_SCHLEIFE_C
	tst YL
	brne SD_CMD24_SCHLEIFE_C
	; wiederherstellen 
	pop ZH
	pop ZL
	pop YH
	pop YL
; ------------------------------------------------------------------------------
	;call SPI_DEBUG_ANZEIGE
SD_CMD24_s2:
	ldi temp9,20
SD_CMD24_s2w:
	call SPI_TX_xFF_RX_TEMP	
	cpi temp, 0xE5		; auf 0xE5 warten	
	breq SD_CMD24_s3
	dec temp9
	brne SD_CMD24_s2w
; ------------------------------------------------------------------------------
SD_CMD24_s3:
	ldi temp9,20
	call SPI_TX_xFF_RX_TEMP	
	cpi temp, 0xFF		; auf 0xFF warten	
	breq SD_CMD24_OK
	dec temp9
	brne SD_CMD24_s3
	rjmp SD_CMD24_ERROR
; ------------------------------------------------------------------------------
SD_CMD24_ERROR:
	mov FEHLER_CODE,VOLL
	call SPI_TX_xFF_RX_TEMP	
	sbi  (SPI_PORT_CS),(SPI_CS)	; CD auf HIGH
	call SPI_TX_xFF_RX_TEMP	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
ret
; ------------------------------------------------------------------------------
SD_CMD24_OK:
	call SPI_TX_xFF_RX_TEMP	
	sbi  (SPI_PORT_CS),(SPI_CS)	; CD auf HIGH
	call SPI_TX_xFF_RX_TEMP	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD55 das "Prefix" fr ein ACMD												
CMD55_PREFIX_ACMD:
	ldi temp1, 0x77
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	call SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
	call SPI_DUMMY				; DUMMY		
; ------------------------------------------------------------------------------
	;call SPI_ANZEIGE
	call SPI_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP: temp1...6																
;																				
SD_TX_KOMMANDO_TEMP1_6:
	cbi  (SPI_PORT_CS),(SPI_CS)	; CS auf LOW !!!
	; kurze PAUSE		
	nop
	nop
	; temp1...6 senden	
	mov temp,temp1
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	mov temp,temp2
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	mov temp,temp3
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	mov temp,temp4
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	mov temp,temp5
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
	mov temp,temp6
	call SPI_TX_RX_TEMP		; INP/OUT: TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################









