;5.3.2 CSD Register (CSD Version 1.0)
; CSD structure CSD_STRUCTURE 2 00b R [127:126]
; reserved - 6 00 0000b R [125:120]
;data read access-time-1 TAAC 8 xxh R [119:112]
;data read access-time-2 in CLKcycles (NSAC*100)NSAC 8 xxh R [111:104]
;max. data transfer rate TRAN_SPEED 8 32h or 5Ah R [103:96]
;card command classes CCC 12 01x110110101b R [95:84]
;max. read data block length READ_BL_LEN 4 xh R [83:80]
;partial blocks for read allowed READ_BL_PARTIAL 1 1b R [79:79]
;write block misalignment WRITE_BLK_MISALIGN 1 xb R [78:78]
;read block misalignment READ_BLK_MISALIGN 1 xb R [77:77]
;DSR implemented DSR_IMP 1 xb R [76:76]
;reserved - 2 00b R [75:74]
;device size C_SIZE 12 xxxh R [73:62]
;max. read current @VDD min VDD_R_CURR_MIN 3 xxxb R [61:59]
;max. read current @VDD max VDD_R_CURR_MAX 3 xxxb R [58:56]
;max. write current @VDD min VDD_W_CURR_MIN 3 xxxb R [55:53]
;max. write current @VDD max VDD_W_CURR_MAX 3 xxxb R [52:50]
;device size multiplier C_SIZE_MULT 3 xxxb R [49:47]
;erase single block enable ERASE_BLK_EN 1 xb R [46:46]
;erase sector size SECTOR_SIZE 7 xxxxxxxb R [45:39]
;write protect group size WP_GRP_SIZE 7 xxxxxxxb R [38:32]
;write protect group enable WP_GRP_ENABLE 1 xb R [31:31]
;reserved (Do not use) 2 00b R [30:29]
;write speed factor R2W_FACTOR 3 xxxb R [28:26]
;max. write data block length WRITE_BL_LEN 4 xxxxb R [25:22]
;partial blocks for write allowed WRITE_BL_PARTIAL 1 xb R [21:21]
;reserved - 5 00000b R [20:16]
;File format group FILE_FORMAT_GRP 1 xb R/W(1) [15:15]
;copy flag (OTP) COPY 1 xb R/W(1) [14:14]
;permanent write protection PERM_WRITE_PROTECT 1 xb R/W(1) [13:13]
;temporary write protection TMP_WRITE_PROTECT 1 xb R/W [12:12]
;File format FILE_FORMAT 2 xxb R/W(1) [11:10]
;reserved 2 00b R/W [9:8]
;CRC CRC 7 xxxxxxxb R/W [7:1]
;not used, always1 - 1 1b - [0:0]
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CALC_CSD:
	ldi ZL,LOW (adr_SD_CSD_REGISTER_BEREICH+15)	; Initialisierung	
	ldi ZH,HIGH(adr_SD_CSD_REGISTER_BEREICH+15)
; ------------------------------------------------------------------------------
; "CSD_STRUCTURE" herausfiltern	[127:126]										
	ldi temp8,126						; START	
	ldi temp9,127						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_STRUCTURE),temp1
	cpi temp1,1							; Version1/2
	breq SD_CALC_CSD_VERSION2
	rjmp SD_CALC_CSD_VERSION1
; ------------------------------------------------------------------------------
; "C_SIZE" herausfiltern [69:48]												
; memory capacity = (C_SIZE+1) * 512KByte										
SD_CALC_CSD_VERSION2:
	ldi temp8,48						; START	
	ldi temp9,69						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_0),temp1
	STS(adr_SD_CSD_C_SIZE_1),temp2
	STS(adr_SD_CSD_C_SIZE_2),temp3
	STS(adr_SD_CSD_C_SIZE_3),temp4
	; memory capacity = (C_SIZE+1) * 512KByte
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	ldi temp9,9
SD_CALC_CSD_s:
	LSL temp1			; links	
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CALC_CSD_s
	call FUNKTION_DIVISION_32_1000	; durch 1000
	STS(adr_SD_CSD_CAPACITY_0),temp1
	STS(adr_SD_CSD_CAPACITY_1),temp2
	STS(adr_SD_CSD_CAPACITY_2),temp3
	STS(adr_SD_CSD_CAPACITY_3),temp4

ret
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; "READ_BL_LEN" herausfiltern [83:80] 4Bit										
SD_CALC_CSD_VERSION1:
	ldi temp8,80						; START	
	ldi temp9,83						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_READ_BL_LEN),temp1
; ------------------------------------------------------------------------------
; "C_SIZE" herausfiltern [73:62] 12Bit											
	ldi temp8,62						; START	
	ldi temp9,73						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_0),temp1
	STS(adr_SD_CSD_C_SIZE_1),temp2
	STS(adr_SD_CSD_C_SIZE_2),temp3
	STS(adr_SD_CSD_C_SIZE_3),temp4
; ------------------------------------------------------------------------------
; "C_SIZE_MULT" herausfiltern [49:47] 											
	ldi temp8,47						; START	
	ldi temp9,49						; ENDE	
	call FUNKTION_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_MULT),temp1
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)	
	mov temp9,temp1
	subi temp9,(-2)		; +2
	ldi temp1,LOW (1)
	ldi temp2,HIGH(1)
SD_CMD9_MU:
	LSL temp1			; links	
	ROL temp2
	dec temp9
	brne SD_CMD9_MU
	STS(adr_SD_CSD_MULT_L),temp1
	STS(adr_SD_CSD_MULT_H),temp2
; ------------------------------------------------------------------------------
;																				
; memory capacity = BLOCKNR * BLOCK_LEN											
; BLOCKNR = (C_SIZE+1) * MULT													
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)								
; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)								
;																				

	; BLOCKNR = (C_SIZE+1) * MULT												
	LDS temp1,(adr_SD_CSD_C_SIZE_0)
	LDS temp2,(adr_SD_CSD_C_SIZE_1)
	add temp1,EINS
	adc temp2,NULL
	LDS temp3,(adr_SD_CSD_MULT_L)
	LDS temp4,(adr_SD_CSD_MULT_H)
	call FUNKTION_MULTIPLIKATION_16_16
	STS(adr_SD_CSD_BLOCKNR_0),temp1
	STS(adr_SD_CSD_BLOCKNR_1),temp2
	STS(adr_SD_CSD_BLOCKNR_2),temp3
	STS(adr_SD_CSD_BLOCKNR_3),temp4
	; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)
	LDS temp9,(adr_SD_CSD_READ_BL_LEN)
SD_CMD9_BL:
	LSL temp1			; links	
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CMD9_BL
	call FUNKTION_DIVISION_32_1000	; durch 1000
	call FUNKTION_DIVISION_32_1000	; durch 1000
	STS(adr_SD_CSD_CAPACITY_0),temp1
	STS(adr_SD_CSD_CAPACITY_1),temp2
	STS(adr_SD_CSD_CAPACITY_2),temp3
	STS(adr_SD_CSD_CAPACITY_3),temp4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
