; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; 255				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; ZEIT NULL			
	STS(adr_hh),NULL
	STS(adr_mm),NULL
	STS(adr_ss),NULL
	; DATUM				
	ldi temp,1
	STS(adr_TAG),  temp
	ldi temp,4
	STS(adr_MONAT),temp
	ldi temp,17
	STS(adr_JAHR), temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Watchdog aktivieren (max. Zeit)												
WDR_INITIALISIERUNG:
	ldi temp,(1<<WDCE)|(1<<WDE)  
	sts WDTCSR,temp       
	ldi temp,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	sts WDTCSR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR														
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL	
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS	
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL	
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	CLI 										; Global Interrupt Disable
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; ROT		
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	WDR
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	

	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	rcall wait_100ms
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	rcall wait_100ms
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	rcall wait_100ms

	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEST_ZAEHLER_PLUS:
	push temp1
	push temp2
	push temp3
	push temp4
	LDS temp1,(adr_TEST_ZAEHLER_0)
	LDS temp2,(adr_TEST_ZAEHLER_1)
	LDS temp3,(adr_TEST_ZAEHLER_2)
	LDS temp4,(adr_TEST_ZAEHLER_3)
	add temp1,EINS
	add temp2,NULL
	add temp3,NULL
	add temp4,NULL
	STS(adr_TEST_ZAEHLER_0),temp1
	STS(adr_TEST_ZAEHLER_1),temp2
	STS(adr_TEST_ZAEHLER_2),temp3
	STS(adr_TEST_ZAEHLER_3),temp4
	pop temp4
	pop temp3
	pop temp2
	pop temp1
ret	
; ------------------------------------------------------------------------------
TEST_ZAEHLER_CLEAR:
	STS(adr_TEST_ZAEHLER_0),NULL
	STS(adr_TEST_ZAEHLER_1),NULL
	STS(adr_TEST_ZAEHLER_2),NULL
	STS(adr_TEST_ZAEHLER_3),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


