; ##############################################################################
; ##############################################################################
; ##############################################################################
; SPCR => SPIE SPE DORD MSTR CPOL CPHA SPR1 SPR0 (SPI Control Register)			
; 																				
; SPI Mode Conditions Leading Edge Trailing eDge								
; 0 CPOL=0, CPHA=0 Sample (Rising) 	Setup (Falling)								
; 1 CPOL=0, CPHA=1 Setup (Rising) 	Sample (Falling)							
; 2 CPOL=1, CPHA=0 Sample (Falling) Setup (Rising)								
; 3 CPOL=1, CPHA=1 Setup (Falling) 	Sample (Rising)								
; 																				
; SPI2X SPR1 SPR0 	SCK Frequency												
; 0 	0 	 0 		fosc/4														
; 0 	0 	 1 		fosc/16														
; 0 	1 	 0 		fosc/64														
; 0 	1 	 1 		fosc/128													
;*1 	0 	 0 		fosc/2														
; 1 	0 	 1 		fosc/8														
; 1 	1 	 0 		fosc/32														
; 1 	1 	 1 		fosc/64														
; 																				
SPI_INITIALISIERUNG:
	; PORTS auf AUSGANG				
	sbi (SPI_DDR_CS)  ,(SPI_CS)		
	sbi (SPI_DDR_MOSI),(SPI_MOSI)
	sbi (SPI_DDR_SCK) ,(SPI_SCK)
	cbi (SPI_DDR_MISO),(SPI_MISO)	; PORTS auf EINGANG				
	; setzen						
	sbi (SPI_PORT_CS)  ,(SPI_CS)	; HIGH (LOW=aktiv)
	cbi (SPI_PORT_MISO),(SPI_MISO)
	; diese PAUSE ist wichtig		
	call wait_10ms

	ldi temp,(0<<SPIE)|(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(1<<SPR1)|(1<<SPR0)
	out SPCR,temp

	ldi temp,(0<<SPI2X)
	out SPSR,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_OFF:
	; SPI_OFF				
	out SPCR,NULL
	out SPSR,NULL
	; auf LOW				
	cbi (SPI_PORT_CS)  ,(SPI_CS)
	cbi (SPI_PORT_MOSI),(SPI_MOSI)
	cbi (SPI_PORT_MISO),(SPI_MISO)
	cbi (SPI_PORT_SCK) ,(SPI_SCK)
	; PORTS auf AUSGANG		
	sbi (SPI_DDR_CS)  ,(SPI_CS)
	sbi (SPI_DDR_MOSI),(SPI_MOSI)
	sbi (SPI_DDR_MISO),(SPI_MISO)
	sbi (SPI_DDR_SCK) ,(SPI_SCK)
	call WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: TEMP																		
; OUT: TEMP																		
SPI_TX_RX_TEMP:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	out SPDR,temp			; Start transmission of data 	
SPI_TX_RX_TEMP_w:
	in temp,SPSR
	sbrs temp,SPIF
	rjmp SPI_TX_RX_TEMP_w	; Wait for transmission complete
	in temp, SPDR			; DATENBYTE EINLESEN			
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: temp																		
SPI_TX_xFF_RX_TEMP:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	ldi temp, 0xFF			; DUMMY (xFF)					
	out SPDR,temp			; Start transmission of data 	
SPI_RX_TEMP_w:
	in temp,SPSR
	sbrs temp,SPIF
	rjmp SPI_RX_TEMP_w		; Wait for transmission complete
	in temp, SPDR			; DATENBYTE EINLESEN			
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_CLEAR:
	call SPI_DUMMY_255
	sbi  (SPI_PORT_CS),(SPI_CS)	; CD auf HIGH	
	call SPI_DUMMY_255
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_DUMMY:
	rcall SPI_TX_xFF_RX_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_DUMMY_255:
	push temp9
	ldi temp9,255
SPI_DUMMY_255s:
	rcall SPI_TX_xFF_RX_TEMP
	dec temp9
	brne SPI_DUMMY_255s
	pop temp9
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_DEBUG_ANZEIGE:
	call LCD_ZEILE1	; ZEILE1	
	call SPI_DEBUG_ZEILE
	call LCD_ZEILE2	; ZEILE2	
	call SPI_DEBUG_ZEILE
	call LCD_ZEILE3	; ZEILE3	
	call SPI_DEBUG_ZEILE
	call LCD_ZEILE4	; ZEILE4	
	call SPI_DEBUG_ZEILE
;	call PROGRAMM_STOP	
	call WAIT_100ms
	call WAIT_1s
ret
; ------------------------------------------------------------------------------
SPI_DEBUG_ZEILE:
	push temp1
	push temp9
	ldi temp9,8
SPI_DEBUG_s:
	WDR
	call SPI_TX_xFF_RX_TEMP		; OUT:temp
	mov temp1,temp
	call LCD_ANZEIGE_HEX_TEMP1
	dec temp9
	brne SPI_DEBUG_s
	pop temp9
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


