; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CSn2 CSn1 CSn0																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/O/1 (No prescaling)										
; 	0 	1 	0 	clkI/O/8 (From prescaler)										
; 	0 	1 	1 	clkI/O/64 (From prescaler)										
; *	1 	0 	0 	clkI/O/256 (From prescaler)										
; 	1 	0 	1 	clkI/O/1024 (From prescaler)									
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER1_INITIALISIERUNG:
	;  TCCR1B  Timer/Counter 1 Control Register B			
	ldi temp, (0<<ICNC1)| (0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(1<<CS12)|(0<<CS11)|(0<<CS10)
	STS TCCR1B,temp
	; TIMSK1  Timer/Counter1 Interrupt Mask Register		
	ldi temp, (0<<ICIE1)| (0<<OCIE1B)|(0<<OCIE1A)|(1<<TOIE1)
	STS TIMSK1,temp
	; STARTWERT												
	ldi temp,HIGH(TIMERWERT1)
	STS TCNT1H,temp			; HIGH	
	ldi temp,LOW(TIMERWERT1)
	STS TCNT1L,temp			; LOW	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;  1s Takt																		
TIM1_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	STS TCNT1H,temp			; HIGH	
	ldi temp,LOW(TIMERWERT1)
	STS TCNT1L,temp			; LOW	
; -------------------------------
	rcall ZEIT
; ----------------------------------
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CSn2 CSn1 CSn0																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
; * 0 	0 	1 	clkI/O/1 (No prescaling)										
; 	0 	1 	0 	clkI/O/8 (From prescaler)										
; 	0 	1 	1 	clkI/O/64 (From prescaler)										
; 	1 	0 	0 	clkI/O/256 (From prescaler)										
; 	1 	0 	1 	clkI/O/1024 (From prescaler)									
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER1_INITIALISIERUNG_CTC:
	; TCCR1A  Timer/Counter 1 Control Register A			
	ldi temp, (0<<COM1A1)| (1<<COM1A0)|(0<<COM1B1)|(1<<COM1B0)|(0<<WGM11)|(0<<WGM10)
	STS TCCR1A,temp
	; TCCR1B  Timer/Counter 1 Control Register B			
	ldi temp, (0<<ICNC1)| (0<<ICES1)|(0<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)
	STS TCCR1B,temp
	; TCCR1C  Timer/Counter 1 Control Register C			
	ldi temp, (0<<FOC1A)|(0<<FOC1B)
	STS TCCR1C,temp
	; TIMSK1  Timer/Counter1 Interrupt Mask Register		
	ldi temp, (0<<ICIE1)| (0<<OCIE1B)|(0<<OCIE1A)|(0<<TOIE1)
	STS TIMSK1,temp
	; OCR1AH and OCR1AL  Output Compare Register 1 A		
	ldi temp,HIGH(200)
	STS OCR1AH,temp
	ldi temp,LOW (200)
	STS OCR1AL,temp
	; auf AUSGANG											
;	sbi DDRB,PB1	; PIN OC1A
;	sbi DDRB,PB2	; PIN OC1B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:
	; FREIGABE_PROGRAMM
	STS(adr_FREIGABE_PROGRAMM),EINS

	LDS temp,(adr_ss)	; aus SRAM laden	
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	


	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	

	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	


	LDS temp,(adr_TAG)
	inc temp
	STS (adr_TAG),temp


	rcall ZEIT_TAGE_MONAT			; OUT: temp1 (Anzahl der Tage im Monat)

	LDS temp,(adr_TAG)

	cp temp, temp1					; VERGLEICH	
	brlo ZEIT_ZAEHLER_TAG_FERTIG	; kleiner => Sprung fertig
	breq ZEIT_ZAEHLER_TAG_FERTIG	; gleich  => SPRUNG fertig
	brsh ZEIT_ZAEHLER_MONAT
ZEIT_ZAEHLER_TAG_FERTIG:
	ret
;													
ZEIT_ZAEHLER_MONAT:
	STS (adr_TAG),EINS

	LDS temp,(adr_MONAT)
	inc temp
	STS (adr_MONAT),temp
	cpi temp,13
	brsh ZEIT_ZAEHLER_JAHR
	ret
;													
ZEIT_ZAEHLER_JAHR:
	STS (adr_MONAT),EINS

	LDS temp,(adr_JAHR)
	inc temp
	STS (adr_JAHR),temp

ret
;###################################################################
;###################################################################
;###################################################################
; OUTPUT: TEMP1 => ANZAHl der TAGE im MONAT							
ZEIT_TAGE_MONAT:
	; MONAT laden	
	LDS temp,(adr_MONAT)

	cpi temp,1					;1
	breq ZEIT_TAGE_MONAT_31
	cpi temp,2					;2
	breq ZEIT_TAGE_MONAT_28
	cpi temp,3					;3
	breq ZEIT_TAGE_MONAT_31
	cpi temp,4					;4
	breq ZEIT_TAGE_MONAT_30
	cpi temp,5					;5
	breq ZEIT_TAGE_MONAT_31
	cpi temp,6					;6
	breq ZEIT_TAGE_MONAT_30
	cpi temp,7					;7
	breq ZEIT_TAGE_MONAT_31
	cpi temp,8					;8
	breq ZEIT_TAGE_MONAT_31
	cpi temp,9					;9
	breq ZEIT_TAGE_MONAT_30
	cpi temp,10					;10
	breq ZEIT_TAGE_MONAT_31
	cpi temp,11					;11
	breq ZEIT_TAGE_MONAT_30
	cpi temp,12					;12
	breq ZEIT_TAGE_MONAT_31
	rjmp ZEIT_TAGE_MONAT_31

ZEIT_TAGE_MONAT_28:
	ldi temp1,28
	ret
ZEIT_TAGE_MONAT_30:
	ldi temp1,30
	ret
ZEIT_TAGE_MONAT_31:
	ldi temp1,31
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

