;												
; SD-KARTE und ATmega328p						
; Bernhard.Erfurt@gmx.de						
; 05/2017										
;												
; https://www.mikrocontroller.net/topic/87431	
; https://www.uni-koblenz.de/~physik/informatik/ECC/sd.pdf	
; http://elm-chan.org/docs/mmc/mmc_e.html					
; http://www.ulrichradig.de/home/index.php/avr/mmc-sd		

; LED ROT blinkt: 			Programm Check Error
; LED ROT+GELB blinkt: 		Interrupt Error		
; LED ROT+GELB+GRN blinkt:	

; ATmega328p 										
.include "m328pdef.inc"
; KONSTANTEN									
.equ CPU_TAKT		= 8000000			; 8 MHz		
; SPI											
.equ SPI_CS			= 2
.equ SPI_MOSI		= 3
.equ SPI_MISO		= 4
.equ SPI_SCK		= 5
.equ SPI_DDR_CS		= DDRB
.equ SPI_DDR_MOSI	= DDRB
.equ SPI_DDR_MISO	= DDRB
.equ SPI_DDR_SCK	= DDRB
.equ SPI_PORT_CS	= PORTB
.equ SPI_PORT_MOSI	= PORTB
.equ SPI_PORT_MISO	= PORTB
.equ SPI_PORT_SCK	= PORTB
; TASTE "MENUE-PLUS"							
.equ TASTE_MENUE_PLUS_PIN_NR		= 0
.equ TASTE_MENUE_PLUS_PIN			= PIND
.equ TASTE_MENUE_PLUS_DDR			= DDRD
.equ TASTE_MENUE_PLUS_PORT			= PORTD
.equ TASTE_MENUE_PLUS				= 1			; Tastenwert	
; TASTE "MENUE-MINUS"							
.equ TASTE_MENUE_MINUS_PIN_NR		= 1
.equ TASTE_MENUE_MINUS_PIN			= PIND
.equ TASTE_MENUE_MINUS_DDR			= DDRD
.equ TASTE_MENUE_MINUS_PORT			= PORTD
.equ TASTE_MENUE_MINUS				= 2 		; Tastenwert	
; TASTE "PLUS"									
.equ TASTE_PLUS_PIN_NR				= 2
.equ TASTE_PLUS_PIN					= PIND
.equ TASTE_PLUS_DDR					= DDRD
.equ TASTE_PLUS_PORT				= PORTD
.equ TASTE_PLUS						= 4 		; Tastenwert	
; TASTE "MINUS"									
.equ TASTE_MINUS_PIN_NR				= 3
.equ TASTE_MINUS_PIN				= PIND
.equ TASTE_MINUS_DDR				= DDRD
.equ TASTE_MINUS_PORT				= PORTD
.equ TASTE_MINUS					= 8 		; Tastenwert	
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRC
.equ LCD_DATA1_DDR					= DDRC
.equ LCD_DATA2_DDR					= DDRC
.equ LCD_DATA3_DDR					= DDRC
.equ LCD_DATA0_PORT					= PORTC
.equ LCD_DATA1_PORT					= PORTC
.equ LCD_DATA2_PORT					= PORTC
.equ LCD_DATA3_PORT					= PORTC
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 0
; LCD_ENABLE									
.equ LCD_EN_DDR						= DDRB
.equ LCD_EN_PORT					= PORTB
.equ LCD_EN							= 1


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN								= SRAM_START			; START Adresse 		

.equ adr_TASTE								= SRAM_START+2			; Tastaturwert		
.equ adr_MENUE								= SRAM_START+3			; MENUE-AUSWAHL		

.equ adr_ss									= SRAM_START+10
.equ adr_mm									= SRAM_START+11
.equ adr_hh									= SRAM_START+12
.equ adr_TAG								= SRAM_START+13
.equ adr_MONAT								= SRAM_START+14
.equ adr_JAHR								= SRAM_START+15

.equ adr_TEST_ZAEHLER_0						= SRAM_START+60
.equ adr_TEST_ZAEHLER_1						= SRAM_START+61
.equ adr_TEST_ZAEHLER_2						= SRAM_START+62
.equ adr_TEST_ZAEHLER_3						= SRAM_START+63


.equ adr_SD_CSD_STRUCTURE					= SRAM_START+286
.equ adr_SD_CSD_READ_BL_LEN 				= SRAM_START+287 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0					= SRAM_START+288	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1					= SRAM_START+289	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_2					= SRAM_START+290	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_3					= SRAM_START+291	; Register CSD =>C_SIZE			

.equ adr_SD_CSD_C_SIZE_MULT					= SRAM_START+293 	; Register CSD =>C_SIZE_MULT	

.equ adr_SD_CSD_MULT_L						= SRAM_START+294
.equ adr_SD_CSD_MULT_H						= SRAM_START+295

.equ adr_SD_CSD_BLOCKNR_0					= SRAM_START+296
.equ adr_SD_CSD_BLOCKNR_1					= SRAM_START+297
.equ adr_SD_CSD_BLOCKNR_2					= SRAM_START+298
.equ adr_SD_CSD_BLOCKNR_3					= SRAM_START+299

.equ adr_SD_CSD_CAPACITY_0					= SRAM_START+300
.equ adr_SD_CSD_CAPACITY_1					= SRAM_START+301
.equ adr_SD_CSD_CAPACITY_2					= SRAM_START+302
.equ adr_SD_CSD_CAPACITY_3					= SRAM_START+303

.equ adr_SD_PHYS_SEKTOR_BYTE0				= SRAM_START+310	; Physische Adresse eines Sektors (Bootsektor=0)
.equ adr_SD_PHYS_SEKTOR_BYTE1				= SRAM_START+311
.equ adr_SD_PHYS_SEKTOR_BYTE2				= SRAM_START+312
.equ adr_SD_PHYS_SEKTOR_BYTE3				= SRAM_START+313

.equ adr_SD_CSD_REGISTER_BEREICH			= SRAM_START+320

.equ adr_SD_CID_REGISTER_BEREICH			= SRAM_START+350

.equ adr_SD_DATEN							= SRAM_START+380	; DATENBYTES				


.equ adr_SRAM_CHECK							= SRAM_START+980	; SRAM CHECK muss immer "S" sein

; REGISTER										

.def FEHLER_CODE= R8

.def NULL 		= R10
.def EINS	 	= R11
.def VOLL   	= R12

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

.cseg							;Beginn eines Code-Segmentes	
.org 0							;Startadresse=0					
.org 0x0000 jmp RESET 			; Reset Handler										
.org 0x0002 jmp INTERRUPT_ERROR ; EXT_INT0 		; IRQ0 Handler						
.org 0x0004 jmp INTERRUPT_ERROR ; EXT_INT1 		; IRQ1 Handler						
.org 0x0006 jmp INTERRUPT_ERROR ; PCINT0 		; PCINT0 Handler					
.org 0x0008 jmp INTERRUPT_ERROR ; PCINT1 		; PCINT1 Handler					
.org 0x000A jmp INTERRUPT_ERROR ; PCINT2 		; PCINT2 Handler					
.org 0x000C jmp INTERRUPT_ERROR ; WDT 			; Watchdog Timer Handler			
.org 0x000E jmp INTERRUPT_ERROR ; TIM2_COMPA 	; Timer2 Compare A Handler			
.org 0x0010 jmp INTERRUPT_ERROR ; TIM2_COMPB 	; Timer2 Compare B Handler			
.org 0x0012 jmp INTERRUPT_ERROR ; TIM2_OVF 		; Timer2 Overflow Handler			
.org 0x0014 jmp INTERRUPT_ERROR ; TIM1_CAPT 	; Timer1 Capture Handler			
.org 0x0016 jmp INTERRUPT_ERROR ; TIM1_COMPA 	; Timer1 Compare A Handler			
.org 0x0018 jmp INTERRUPT_ERROR ; TIM1_COMPB 	; Timer1 Compare B Handler			
.org 0x001A jmp INTERRUPT_ERROR ;jmp TIM1_OVF 		; Timer1 Overflow Handler		
.org 0x001C jmp INTERRUPT_ERROR ;TIM0_COMPA 	; Timer0 Compare A Handler			
.org 0x001E jmp INTERRUPT_ERROR ; TIM0_COMPB 	; Timer0 Compare B Handler			
.org 0x0020 jmp INTERRUPT_ERROR ; TIM0_OVF 		; Timer0 Overflow Handler			
.org 0x0022 jmp INTERRUPT_ERROR ; SPI_STC 		; SPI Transfer Complete Handler		
.org 0x0024 jmp INTERRUPT_ERROR ; USART_RXC 	; USART, RX Complete Handler		
.org 0x0026 jmp INTERRUPT_ERROR ; USART_UDRE 	; USART, UDR Empty Handler			
.org 0x0028 jmp INTERRUPT_ERROR ; USART_TXC 	; USART, TX Complete Handler		
.org 0x002A jmp INTERRUPT_ERROR ; ADC 			; ADC Conversion Complete Handler	
.org 0x002C jmp INTERRUPT_ERROR ; EE_RDY 		; EEPROM Ready Handler				
.org 0x002E jmp INTERRUPT_ERROR ; ANA_COMP 		; Analog Comparator Handler			
.org 0x0030 jmp INTERRUPT_ERROR ; TWI 			; 2-wire Serial Interface Handler	
.org 0x0032 jmp INTERRUPT_ERROR ; SPM_RDY 		; Store Program Memory Ready Handler

INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT) ,(LED_ROT_PIN_NR)		; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

	call WDR_INITIALISIERUNG	; WDR_INITIALISIERUNG			
	call SRAM_CLEAR				; SRAM_CLEAR					
	call PORT_CLEAR				; PORT_CLEAR					
	call STARTWERTE				; STARTWERTE					
	call LED_INITIALISIERUNG	; LED_INITIALISIERUNG			
	call LED_TEST				; LED-TEST						
	call LCD_INITIALISIERUNG	; LCD_INITIALISIERUNG			
	call ANZEIGE_BEGRUESSUNG
	call WAIT_1s
	call TASTEN_INITIALISIERUNG; TASTEN_INITIALISIERUNG		
	call SPI_INITIALISIERUNG	; SPI_INITIALISIERUNG			
	call PROGRAMM_CHECK		; PROGRAMM_CHECK				
	sei							; Interrupts freigeben			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; normale Programmschleife														
LOOP:
	WDR		; Watch-Dog-RESET	
	call PROGRAMM_CHECK
	call SD_CHECK
	call TASTEN_ABFRAGE
	call MENUE
	LDS temp,(adr_ss)
	inc temp
	STS(adr_ss),temp
	call WAIT_100ms
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SD_SPI.asm"
.include "SD_SD.asm"
.include "SD_SD_CALC.asm"	; SD Berechnungen
.include "SD_MENUE.asm"
.include "SD_SONSTIGES.asm"
.include "SD_TASTEN.asm"
.include "SD_LCD_ini.asm"
.include "SD_LCD_ANZEIGE.asm"
.include "SD_FUNKTIONEN.asm"
.include "SD_WAIT.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "SD-KARTE ",0
TEXT_BEGRUESSUNG_2:
.db "ATmega328p ",0
TEXT_BEGRUESSUNG_3:
.db "LCD4x16 05/2017",0





